
Ruby - Feature #2837

Compile-time constant for HEAP_GROWTH_FACTOR (patch attached)

03/05/2010 05:20 AM - adgar (Michael Edgar)

Status: Closed   

Priority: Normal   

Assignee: authorNari (Narihiro Nakamura)   

Target version: 2.6   

Description

=begin

The GC currently increases the size at which newly-created heaps by a factor of 1.8 for each heap.  Some find it appropriate to

modify this value (REE uses a value of 1 instead of 1.8, for example).  In the trunk version of this code, that value is hard-coded in as

a constant at 1.8 in gc.c:980.

I've included a patch to expose this as a compile-time constant (HEAP_GROW_FACTOR), and also included getters and setters in

the style of the patch I submitted in Issue 1047: http://redmine.ruby-lang.org/issues/show/1047 .

=end

Related issues:

Related to Ruby - Feature #8015: [patch] tuneable HEAP_GROWTH_FACTOR Closed 03/05/2013

History

#1 - 03/05/2010 01:51 PM - nobu (Nobuyoshi Nakada)

=begin

Hi,

At Fri, 5 Mar 2010 05:20:36 +0900,

Michael Edgar wrote in [ruby-core:28487]:

I've included a patch to expose this as a compile-time

constant (HEAP_GROW_FACTOR), and also included getters and

setters in the style of the patch I submitted in Issue 1047:

http://redmine.ruby-lang.org/issues/show/1047 .

 At least, they must be members of rb_objspace_t, and the

argument ranges should be checked.

--

Nobu Nakada

=end

#2 - 03/05/2010 06:34 PM - adgar (Michael Edgar)

=begin

At least, they must be members of rb_objspace_t, and the

argument ranges should be checked.

 I considered this, though they are compile-time constants that are being replaced.  Pre-patch, they aren't currently in the rb_objspace_t.  The

malloc_limit accessor affects the currently rb_objspace_t as appropriate, but the HEAP_MIN_SLOTS accessors don't since that value doesn't directly

affect existing structures.  I can certainly put a heap_min_slots member into rb_objspace_t.

Also, which argument ranges are considered valid? Perhaps a malloc_limit of at least 10K? I don't know how small of a footprint Ruby could fit into

that people would like. While most people increase these values beyond their initial defaults, I wouldn't want to set the limit too low.

Thanks!

=end

#3 - 04/02/2010 08:52 AM - znz (Kazuhiro NISHIYAMA)

- Target version set to 2.0.0

=begin
=end

#4 - 03/18/2012 03:30 PM - nahi (Hiroshi Nakamura)

- Description updated

- Assignee set to authorNari (Narihiro Nakamura)

#5 - 03/18/2012 06:46 PM - shyouhei (Shyouhei Urabe)

- Status changed from Open to Assigned

#6 - 10/27/2012 11:26 AM - authorNari (Narihiro Nakamura)

- Target version changed from 2.0.0 to 2.6

#7 - 03/05/2013 11:02 AM - nobu (Nobuyoshi Nakada)

This patch contains not only the subject but also the accessors.

It isn't acceptable and you should separate them, I think.

#8 - 03/18/2013 12:04 PM - authorNari (Narihiro Nakamura)

- Status changed from Assigned to Closed

I commited r39746.

We can change HEAP_GROWTH_FACTOR via an enviroment variable now.

So I close this ticket.

Thanks.

Files

grow_factor.patch 2 KB 03/05/2010 adgar (Michael Edgar)

Powered by TCPDF (www.tcpdf.org)

06/16/2025 2/2

http://www.tcpdf.org

